require '_h2ph_pre.ph';

unless(defined(&_ASM_IA64_IA32_H)) {
    eval 'sub _ASM_IA64_IA32_H () {1;}' unless defined(&_ASM_IA64_IA32_H);
    require 'linux/config.ph';
    if(defined(&CONFIG_IA32_SUPPORT)) {
	require 'linux/param.ph';
	eval 'sub IA32_PAGE_SHIFT () {12;}' unless defined(&IA32_PAGE_SHIFT);
	eval 'sub IA32_PAGE_SIZE () {(1 <<  &IA32_PAGE_SHIFT);}' unless defined(&IA32_PAGE_SIZE);
	eval 'sub IA32_CLOCKS_PER_SEC () {100;}' unless defined(&IA32_CLOCKS_PER_SEC);
	eval 'sub IA32_TICK {
	    local($tick) = @_;
    	    eval q((($tick) *  &IA32_CLOCKS_PER_SEC /  &CLOCKS_PER_SEC));
	}' unless defined(&IA32_TICK);
	eval 'sub _IA32_NSIG () {64;}' unless defined(&_IA32_NSIG);
	eval 'sub _IA32_NSIG_BPW () {32;}' unless defined(&_IA32_NSIG_BPW);
	eval 'sub _IA32_NSIG_WORDS () {( &_IA32_NSIG /  &_IA32_NSIG_BPW);}' unless defined(&_IA32_NSIG_WORDS);
	eval 'sub _ASM_IA64_ELF_H () {1;}' unless defined(&_ASM_IA64_ELF_H);
	require 'linux/sched.ph';
	require 'asm/processor.ph';
	eval 'sub elf_check_arch {
	    local($x) = @_;
    	    eval q((($x)-> &e_machine ==  &EM_386));
	}' unless defined(&elf_check_arch);
	eval 'sub ELF_CLASS () { &ELFCLASS32;}' unless defined(&ELF_CLASS);
	eval 'sub ELF_DATA () { &ELFDATA2LSB;}' unless defined(&ELF_DATA);
	eval 'sub ELF_ARCH () { &EM_386;}' unless defined(&ELF_ARCH);
	eval 'sub IA32_PAGE_OFFSET () {0xc0000000;}' unless defined(&IA32_PAGE_OFFSET);
	eval 'sub USE_ELF_CORE_DUMP () {1;}' unless defined(&USE_ELF_CORE_DUMP);
	eval 'sub ELF_EXEC_PAGESIZE () { &IA32_PAGE_SIZE;}' unless defined(&ELF_EXEC_PAGESIZE);
	eval 'sub ELF_ET_DYN_BASE () {( &IA32_PAGE_OFFSET/3+ 0x1000000);}' unless defined(&ELF_ET_DYN_BASE);
	eval 'sub ELF_PLAT_INIT {
	    local($_r) = @_;
    	    eval q( &ia64_elf32_init($_r));
	}' unless defined(&ELF_PLAT_INIT);
	eval 'sub elf_addr_t () { &u32;}' unless defined(&elf_addr_t);
	eval 'sub elf_caddr_t () { &u32;}' unless defined(&elf_caddr_t);
	eval 'sub ELF_NGREG () {128;}' unless defined(&ELF_NGREG);
	eval 'sub ELF_NFPREG () {128;}' unless defined(&ELF_NFPREG);
	eval 'sub ELF_HWCAP () {0;}' unless defined(&ELF_HWCAP);
	eval 'sub ELF_PLATFORM () {0;}' unless defined(&ELF_PLATFORM);
	if(defined(&__KERNEL__)) {
	    eval 'sub SET_PERSONALITY {
	        local($EX,$IBCS2) = @_;
    		eval q(( ($current->{personality}) = ($IBCS2) ?  &PER_SVR4 :  &PER_LINUX));
	    }' unless defined(&SET_PERSONALITY);
	}
	eval 'sub IA32_EFLAG () {0x200;}' unless defined(&IA32_EFLAG);
	eval 'sub __USER_CS () {0x23;}' unless defined(&__USER_CS);
	eval 'sub __USER_DS () {0x2b;}' unless defined(&__USER_DS);
	eval 'sub SEG_LIM () {32;}' unless defined(&SEG_LIM);
	eval 'sub SEG_TYPE () {52;}' unless defined(&SEG_TYPE);
	eval 'sub SEG_SYS () {56;}' unless defined(&SEG_SYS);
	eval 'sub SEG_DPL () {57;}' unless defined(&SEG_DPL);
	eval 'sub SEG_P () {59;}' unless defined(&SEG_P);
	eval 'sub SEG_DB () {62;}' unless defined(&SEG_DB);
	eval 'sub SEG_G () {63;}' unless defined(&SEG_G);
	eval 'sub FIRST_TSS_ENTRY () {6;}' unless defined(&FIRST_TSS_ENTRY);
	eval 'sub FIRST_LDT_ENTRY () {( &FIRST_TSS_ENTRY+1);}' unless defined(&FIRST_LDT_ENTRY);
	eval 'sub _TSS {
	    local($n) = @_;
    	    eval q(((( $n)<<4)+( &FIRST_TSS_ENTRY<<3)));
	}' unless defined(&_TSS);
	eval 'sub _LDT {
	    local($n) = @_;
    	    eval q(((( $n)<<4)+( &FIRST_LDT_ENTRY<<3)));
	}' unless defined(&_LDT);
	eval 'sub IA64_SEG_DESCRIPTOR {
	    local($base, $limit, $segtype, $nonsysseg, $dpl, $segpresent, $segdb, $granularity) = @_;
    	    eval q((($base) | ($limit <<  &SEG_LIM) | ($segtype <<  &SEG_TYPE) | ($nonsysseg <<  &SEG_SYS) | ($dpl <<  &SEG_DPL) | ($segpresent <<  &SEG_P) | ($segdb <<  &SEG_DB) | ($granularity <<  &SEG_G)));
	}' unless defined(&IA64_SEG_DESCRIPTOR);
	eval 'sub IA32_SEG_BASE () {16;}' unless defined(&IA32_SEG_BASE);
	eval 'sub IA32_SEG_TYPE () {40;}' unless defined(&IA32_SEG_TYPE);
	eval 'sub IA32_SEG_SYS () {44;}' unless defined(&IA32_SEG_SYS);
	eval 'sub IA32_SEG_DPL () {45;}' unless defined(&IA32_SEG_DPL);
	eval 'sub IA32_SEG_P () {47;}' unless defined(&IA32_SEG_P);
	eval 'sub IA32_SEG_HIGH_LIMIT () {48;}' unless defined(&IA32_SEG_HIGH_LIMIT);
	eval 'sub IA32_SEG_AVL () {52;}' unless defined(&IA32_SEG_AVL);
	eval 'sub IA32_SEG_DB () {54;}' unless defined(&IA32_SEG_DB);
	eval 'sub IA32_SEG_G () {55;}' unless defined(&IA32_SEG_G);
	eval 'sub IA32_SEG_HIGH_BASE () {56;}' unless defined(&IA32_SEG_HIGH_BASE);
	eval 'sub IA32_SEG_DESCRIPTOR {
	    local($base, $limit, $segtype, $nonsysseg, $dpl, $segpresent, $avl, $segdb, $granularity) = @_;
    	    eval q((($limit & 0xffff) | ($base & 0xffffff <<  &IA32_SEG_BASE) | ($segtype <<  &IA32_SEG_TYPE) | ($nonsysseg <<  &IA32_SEG_SYS) | ($dpl <<  &IA32_SEG_DPL) | ($segpresent <<  &IA32_SEG_P) | ((($limit >> 16) & 0xf) <<  &IA32_SEG_HIGH_LIMIT) | ($avl <<  &IA32_SEG_AVL) | ($segdb <<  &IA32_SEG_DB) | ($granularity <<  &IA32_SEG_G) | ((($base >> 24) & 0xff) <<  &IA32_SEG_HIGH_BASE)));
	}' unless defined(&IA32_SEG_DESCRIPTOR);
	eval 'sub IA32_IOBASE () {0x2000000000000000;}' unless defined(&IA32_IOBASE);
	eval 'sub IA32_CR0 () {0x80000001;}' unless defined(&IA32_CR0);
	eval 'sub IA32_CR4 () {0;}' unless defined(&IA32_CR4);
	eval 'sub IA32_FSR_DEFAULT () {0x55550000;}' unless defined(&IA32_FSR_DEFAULT);
	eval 'sub IA32_FCR_DEFAULT () {0x17800000037f;}' unless defined(&IA32_FCR_DEFAULT);
	eval 'sub IA32_PTRACE_GETREGS () {12;}' unless defined(&IA32_PTRACE_GETREGS);
	eval 'sub IA32_PTRACE_SETREGS () {13;}' unless defined(&IA32_PTRACE_SETREGS);
	eval 'sub IA32_PTRACE_GETFPREGS () {14;}' unless defined(&IA32_PTRACE_GETFPREGS);
	eval 'sub IA32_PTRACE_SETFPREGS () {15;}' unless defined(&IA32_PTRACE_SETFPREGS);
	eval 'sub ia32_start_thread {
	    local($regs,$new_ip,$new_sp) = @_;
    	    eval q( &do {  &set_fs( &USER_DS);  &ia64_psr($regs)-> &cpl = 3;  &ia64_psr($regs)-> &ri = 0;  &ia64_psr($regs)-> &is = 1;  ($regs->{cr_iip}) = $new_ip;  ($regs->{ar_rsc}) = 0xc;  ($regs->{ar_rnat}) = 0;  ($regs->{loadrs}) = 0;  ($regs->{r12}) = $new_sp; }  &while (0));
	}' unless defined(&ia32_start_thread);
    }
}
1;
