require '_h2ph_pre.ph';

unless(defined(&_ASM_IA64_PAGE_H)) {
    eval 'sub _ASM_IA64_PAGE_H () {1;}' unless defined(&_ASM_IA64_PAGE_H);
    require 'linux/config.ph';
    require 'asm/types.ph';
    if(defined( &CONFIG_IA64_PAGE_SIZE_4KB)) {
	eval 'sub PAGE_SHIFT () {12;}' unless defined(&PAGE_SHIFT);
    }
 elsif(defined( &CONFIG_IA64_PAGE_SIZE_8KB)) {
	eval 'sub PAGE_SHIFT () {13;}' unless defined(&PAGE_SHIFT);
    }
 elsif(defined( &CONFIG_IA64_PAGE_SIZE_16KB)) {
	eval 'sub PAGE_SHIFT () {14;}' unless defined(&PAGE_SHIFT);
    }
 elsif(defined( &CONFIG_IA64_PAGE_SIZE_64KB)) {
	eval 'sub PAGE_SHIFT () {16;}' unless defined(&PAGE_SHIFT);
    } else {
	die("Unsupported\ page\ size\!");
    }
    eval 'sub PAGE_SIZE () {( &__IA64_UL_CONST(1) <<  &PAGE_SHIFT);}' unless defined(&PAGE_SIZE);
    eval 'sub PAGE_MASK () {(~( &PAGE_SIZE - 1));}' unless defined(&PAGE_MASK);
    eval 'sub PAGE_ALIGN {
        local($addr) = @_;
	    eval q(((($addr) +  &PAGE_SIZE - 1) &  &PAGE_MASK));
    }' unless defined(&PAGE_ALIGN);
    if(defined(&__ASSEMBLY__)) {
	eval 'sub __pa {
	    local($x) = @_;
    	    eval q((($x) -  &PAGE_OFFSET));
	}' unless defined(&__pa);
	eval 'sub __va {
	    local($x) = @_;
    	    eval q((($x) +  &PAGE_OFFSET));
	}' unless defined(&__va);
    } else {
	if(defined(&__KERNEL__)) {
	    eval 'sub STRICT_MM_TYPECHECKS () {1;}' unless defined(&STRICT_MM_TYPECHECKS);
	    if(defined(&STRICT_MM_TYPECHECKS)) {
		eval 'sub pte_val {
		    local($x) = @_;
    		    eval q((($x). &pte));
		}' unless defined(&pte_val);
		eval 'sub pmd_val {
		    local($x) = @_;
    		    eval q((($x). &pmd));
		}' unless defined(&pmd_val);
		eval 'sub pgd_val {
		    local($x) = @_;
    		    eval q((($x). &pgd));
		}' unless defined(&pgd_val);
		eval 'sub pgprot_val {
		    local($x) = @_;
    		    eval q((($x). &pgprot));
		}' unless defined(&pgprot_val);
		eval 'sub __pte {
		    local($x) = @_;
    		    eval q((( &pte_t) { ($x) } ));
		}' unless defined(&__pte);
		eval 'sub __pgprot {
		    local($x) = @_;
    		    eval q((( &pgprot_t) { ($x) } ));
		}' unless defined(&__pgprot);
	    } else {
		eval 'sub pte_val {
		    local($x) = @_;
    		    eval q(($x));
		}' unless defined(&pte_val);
		eval 'sub pmd_val {
		    local($x) = @_;
    		    eval q(($x));
		}' unless defined(&pmd_val);
		eval 'sub pgd_val {
		    local($x) = @_;
    		    eval q(($x));
		}' unless defined(&pgd_val);
		eval 'sub pgprot_val {
		    local($x) = @_;
    		    eval q(($x));
		}' unless defined(&pgprot_val);
		eval 'sub __pte {
		    local($x) = @_;
    		    eval q(($x));
		}' unless defined(&__pte);
		eval 'sub __pgd {
		    local($x) = @_;
    		    eval q(($x));
		}' unless defined(&__pgd);
		eval 'sub __pgprot {
		    local($x) = @_;
    		    eval q(($x));
		}' unless defined(&__pgprot);
	    }
	    eval 'sub MAP_NR_DENSE {
	        local($addr) = @_;
    		eval q((( ($addr) -  &PAGE_OFFSET) >>  &PAGE_SHIFT));
	    }' unless defined(&MAP_NR_DENSE);
	    if(defined(&CONFIG_IA64_GENERIC)) {
		require 'asm/machvec.ph';
		eval 'sub virt_to_page {
		    local($kaddr) = @_;
    		    eval q(( &mem_map +  &platform_map_nr($kaddr)));
		}' unless defined(&virt_to_page);
	    }
 elsif(defined ( &CONFIG_IA64_SGI_SN1)) {
		unless(defined(&CONFIG_DISCONTIGMEM)) {
		    eval 'sub virt_to_page {
		        local($kaddr) = @_;
    			eval q(( &mem_map +  &MAP_NR_DENSE($kaddr)));
		    }' unless defined(&virt_to_page);
		}
	    } else {
		eval 'sub virt_to_page {
		    local($kaddr) = @_;
    		    eval q(( &mem_map +  &MAP_NR_DENSE($kaddr)));
		}' unless defined(&virt_to_page);
	    }
	    eval 'sub VALID_PAGE {
	        local($page) = @_;
    		eval q((($page -  &mem_map) <  &max_mapnr));
	    }' unless defined(&VALID_PAGE);
	    eval 'sub __pa {
	        local($x) = @_;
    		eval q(({ &ia64_va  &_v;  ($_v->{l}) = ($x);  ($_v->{f}->{reg}) = 0;  ($_v->{l});}));
	    }' unless defined(&__pa);
	    eval 'sub __va {
	        local($x) = @_;
    		eval q(({ &ia64_va  &_v;  ($_v->{l}) = ($x);  ($_v->{f}->{reg}) = -1;  ($_v->{p});}));
	    }' unless defined(&__va);
	    eval 'sub REGION_NUMBER {
	        local($x) = @_;
    		eval q(({ &ia64_va  &_v;  ($_v->{l}) = ($x);  ($_v->{f}->{reg});}));
	    }' unless defined(&REGION_NUMBER);
	    eval 'sub REGION_OFFSET {
	        local($x) = @_;
    		eval q(({ &ia64_va  &_v;  ($_v->{l}) = ($x);  ($_v->{f}->{off});}));
	    }' unless defined(&REGION_OFFSET);
	    eval 'sub REGION_SIZE () { &REGION_NUMBER(1);}' unless defined(&REGION_SIZE);
	    eval 'sub REGION_KERNEL () {7;}' unless defined(&REGION_KERNEL);
	    eval 'sub BUG () {
	        eval q( &do {  &printk(\\"kernel BUG at %s:%d!\\\\n\\",  &__FILE__,  &__LINE__); *0=0; }  &while (0));
	    }' unless defined(&BUG);
	    eval 'sub PAGE_BUG {
	        local($page) = @_;
    		eval q( &do {  &BUG(); }  &while (0));
	    }' unless defined(&PAGE_BUG);
	}
    }
    eval 'sub PAGE_OFFSET () {0xe000000000000000;}' unless defined(&PAGE_OFFSET);
}
1;
