require '_h2ph_pre.ph';

unless(defined(&_ASM_IA64_SPINLOCK_H)) {
    eval 'sub _ASM_IA64_SPINLOCK_H () {1;}' unless defined(&_ASM_IA64_SPINLOCK_H);
    require 'linux/kernel.ph';
    require 'asm/system.ph';
    require 'asm/bitops.ph';
    require 'asm/atomic.ph';
    undef(&NEW_LOCK) if defined(&NEW_LOCK);
    if(defined(&NEW_LOCK)) {
	eval 'sub SPIN_LOCK_UNLOCKED () {( &spinlock_t) { 0};}' unless defined(&SPIN_LOCK_UNLOCKED);
	eval 'sub spin_lock_init {
	    local($x) = @_;
    	    eval q((($x)-> &lock = 0));
	}' unless defined(&spin_lock_init);
	eval 'sub spin_lock {
	    local($x) = @_;
    	    eval q({  &register \'char\' * &addr  &__asm__ (\\"r31\\") = &-> &lock;  &__asm__  &__volatile__ ( \\"mov r30=1\\\\n\\" \\"mov ar.ccv=r0\\\\n\\" \\";;\\\\n\\"  &IA64_SEMFIX\\"cmpxchg4.acq r30=[%0],r30,ar.ccv\\\\n\\" \\";;\\\\n\\" \\"cmp.ne p15,p0=r30,r0\\\\n\\" \\" br.call.spnt.few b7=ia64_spinlock_contention\\\\n\\" \\";;\\\\n\\" \\"1:\\\\n\\" :: \\"r\\"( &addr) : \\"ar.ccv\\", \\"ar.pfs\\", \\"b7\\", \\"p15\\", \\"r28\\", \\"r29\\", \\"r30\\", \\"memory\\"); });
	}' unless defined(&spin_lock);
	eval 'sub spin_trylock {
	    local($x) = @_;
    	    eval q(({  &register \'long result\';  &__asm__  &__volatile__ ( \\"mov ar.ccv=r0\\\\n\\" \\";;\\\\n\\"  &IA64_SEMFIX\\"cmpxchg4.acq %0=[%2],%1,ar.ccv\\\\n\\" : \\"=r\\"( &result) : \\"r\\"(1), \\"r\\"(($x)-> &lock) : \\"ar.ccv\\", \\"memory\\"); ( &result == 0); }));
	}' unless defined(&spin_trylock);
	eval 'sub spin_is_locked {
	    local($x) = @_;
    	    eval q((($x)-> &lock != 0));
	}' unless defined(&spin_is_locked);
	eval 'sub spin_unlock {
	    local($x) = @_;
    	    eval q( &do {( $x)-> &lock = 0;}  &while (0));
	}' unless defined(&spin_unlock);
	eval 'sub spin_unlock_wait {
	    local($x) = @_;
    	    eval q( &do {}  &while (($x)-> &lock));
	}' unless defined(&spin_unlock_wait);
    } else {
	eval 'sub SPIN_LOCK_UNLOCKED () {( &spinlock_t) { 0};}' unless defined(&SPIN_LOCK_UNLOCKED);
	eval 'sub spin_lock_init {
	    local($x) = @_;
    	    eval q((($x)-> &lock = 0));
	}' unless defined(&spin_lock_init);
	eval 'sub spin_lock {
	    local($x) = @_;
    	    eval q( &__asm__  &__volatile__ ( \\"mov ar.ccv = r0\\\\n\\" \\"mov r29 = 1\\\\n\\" \\";;\\\\n\\" \\"1:\\\\n\\" \\"ld4 r2 = [%0]\\\\n\\" \\";;\\\\n\\" \\"cmp4.eq p0,p7 = r0,r2\\\\n\\" \\" br.cond.spnt.few 1b \\\\n\\"  &IA64_SEMFIX\\"cmpxchg4.acq r2 = [%0], r29, ar.ccv\\\\n\\" \\";;\\\\n\\" \\"cmp4.eq p0,p7 = r0, r2\\\\n\\" \\" br.cond.spnt.few 1b\\\\n\\" \\";;\\\\n\\" :: \\"r\\"(($x)-> &lock) : \\"r2\\", \\"r29\\", \\"memory\\"));
	}' unless defined(&spin_lock);
	eval 'sub spin_is_locked {
	    local($x) = @_;
    	    eval q((($x)-> &lock != 0));
	}' unless defined(&spin_is_locked);
	eval 'sub spin_unlock {
	    local($x) = @_;
    	    eval q( &do {( $x)-> &lock = 0;  &barrier(); }  &while (0));
	}' unless defined(&spin_unlock);
	eval 'sub spin_trylock {
	    local($x) = @_;
    	    eval q(( &cmpxchg_acq(($x)-> &lock, 0, 1) == 0));
	}' unless defined(&spin_trylock);
	eval 'sub spin_unlock_wait {
	    local($x) = @_;
    	    eval q( &do {  &barrier(); }  &while (($x)-> &lock));
	}' unless defined(&spin_unlock_wait);
    }
    eval 'sub RW_LOCK_UNLOCKED () {( &rwlock_t) { 0, 0};}' unless defined(&RW_LOCK_UNLOCKED);
    eval 'sub read_lock {
        local($rw) = @_;
	    eval q( &do { \'int\'  &tmp = 0;  &__asm__  &__volatile__ (\\"1:\\\\t\\" &IA64_SEMFIX\\"fetchadd4.acq %0 = [%1], 1\\\\n\\" \\";;\\\\n\\" \\"tbit.nz p6,p0 = %0, 31\\\\n\\" \\" br.cond.sptk.few 2f\\\\n\\" \\".section .text.lock,\\\\\\"ax\\\\\\"\\\\n\\" \\"2:\\\\t\\" &IA64_SEMFIX\\"fetchadd4.rel %0 = [%1], -1\\\\n\\" \\";;\\\\n\\" \\"3:\\\\tld4.acq %0 = [%1]\\\\n\\" \\";;\\\\n\\" \\"tbit.nz p6,p0 = %0, 31\\\\n\\" \\" br.cond.sptk.few 3b\\\\n\\" \\"br.cond.sptk.few 1b\\\\n\\" \\";;\\\\n\\" \\".previous\\\\n\\" : \\"=&r\\" ( &tmp) : \\"r\\" ($rw): \\"memory\\"); }  &while(0));
    }' unless defined(&read_lock);
    eval 'sub read_unlock {
        local($rw) = @_;
	    eval q( &do { \'int\'  &tmp = 0;  &__asm__  &__volatile__ ( &IA64_SEMFIX\\"fetchadd4.rel %0 = [%1], -1\\\\n\\" : \\"=r\\" ( &tmp) : \\"r\\" ($rw) : \\"memory\\"); }  &while(0));
    }' unless defined(&read_unlock);
    eval 'sub write_lock {
        local($rw) = @_;
	    eval q( &do {  &__asm__  &__volatile__ ( \\"mov ar.ccv = r0\\\\n\\" \\"movl r29 = 0x80000000\\\\n\\" \\";;\\\\n\\" \\"1:\\\\n\\" \\"ld4 r2 = [%0]\\\\n\\" \\";;\\\\n\\" \\"cmp4.eq p0,p7 = r0,r2\\\\n\\" \\" br.cond.spnt.few 1b \\\\n\\"  &IA64_SEMFIX\\"cmpxchg4.acq r2 = [%0], r29, ar.ccv\\\\n\\" \\";;\\\\n\\" \\"cmp4.eq p0,p7 = r0, r2\\\\n\\" \\" br.cond.spnt.few 1b\\\\n\\" \\";;\\\\n\\" :: \\"r\\"($rw) : \\"r2\\", \\"r29\\", \\"memory\\"); }  &while(0));
    }' unless defined(&write_lock);
    eval 'sub write_unlock {
        local($x) = @_;
	    eval q(({ &clear_bit(31, ($x));  &mb();}));
    }' unless defined(&write_unlock);
}
1;
