require '_h2ph_pre.ph';

unless(defined(&_ASM_IA64_SYSTEM_H)) {
    eval 'sub _ASM_IA64_SYSTEM_H () {1;}' unless defined(&_ASM_IA64_SYSTEM_H);
    require 'linux/config.ph';
    require 'asm/page.ph';
    eval 'sub KERNEL_START () {( &PAGE_OFFSET + 0x500000);}' unless defined(&KERNEL_START);
    eval 'sub IVT_END_ADDR () {( &KERNEL_START + 0x8000);}' unless defined(&IVT_END_ADDR);
    eval 'sub ZERO_PAGE_ADDR () {( &IVT_END_ADDR + 0* &PAGE_SIZE);}' unless defined(&ZERO_PAGE_ADDR);
    eval 'sub SWAPPER_PGD_ADDR () {( &IVT_END_ADDR + 1* &PAGE_SIZE);}' unless defined(&SWAPPER_PGD_ADDR);
    eval 'sub GATE_ADDR () {(0xa000000000000000 +  &PAGE_SIZE);}' unless defined(&GATE_ADDR);
    if(defined( &CONFIG_ITANIUM_ASTEP_SPECIFIC) || defined( &CONFIG_ITANIUM_B0_SPECIFIC) || defined( &CONFIG_ITANIUM_B1_SPECIFIC)) {
	eval 'sub IA64_SEMFIX_INSN () { &mf;;}' unless defined(&IA64_SEMFIX_INSN);
	eval 'sub IA64_SEMFIX () {"mf;";}' unless defined(&IA64_SEMFIX);
    } else {
	eval 'sub IA64_SEMFIX_INSN () {1;}' unless defined(&IA64_SEMFIX_INSN);
	eval 'sub IA64_SEMFIX () {"";}' unless defined(&IA64_SEMFIX);
    }
    unless(defined(&__ASSEMBLY__)) {
	require 'linux/kernel.ph';
	require 'linux/types.ph';
	eval 'sub mb () {
	    eval q( &__asm__  &__volatile__ (\\"mf\\" ::: \\"memory\\"));
	}' unless defined(&mb);
	eval 'sub rmb () {
	    eval q( &mb());
	}' unless defined(&rmb);
	eval 'sub wmb () {
	    eval q( &mb());
	}' unless defined(&wmb);
	if(defined(&CONFIG_SMP)) {
	    eval 'sub smp_mb () {
	        eval q( &mb());
	    }' unless defined(&smp_mb);
	    eval 'sub smp_rmb () {
	        eval q( &rmb());
	    }' unless defined(&smp_rmb);
	    eval 'sub smp_wmb () {
	        eval q( &wmb());
	    }' unless defined(&smp_wmb);
	} else {
	    eval 'sub smp_mb () {
	        eval q( &barrier());
	    }' unless defined(&smp_mb);
	    eval 'sub smp_rmb () {
	        eval q( &barrier());
	    }' unless defined(&smp_rmb);
	    eval 'sub smp_wmb () {
	        eval q( &barrier());
	    }' unless defined(&smp_wmb);
	}
	eval 'sub set_mb {
	    local($var, $value) = @_;
    	    eval q( &do { ($var) = ($value);  &mb(); }  &while (0));
	}' unless defined(&set_mb);
	eval 'sub set_wmb {
	    local($var, $value) = @_;
    	    eval q( &do { ($var) = ($value);  &mb(); }  &while (0));
	}' unless defined(&set_wmb);
	if(defined(&CONFIG_IA64_DEBUG_IRQ)) {
	    eval 'sub local_irq_save {
	        local($x) = @_;
    		eval q( &do { \'unsigned long ip\',  &psr;  &__asm__  &__volatile__ (\\"mov %0=psr;; rsm psr.i;;\\" : \\"=r\\" ( &psr) :: \\"memory\\");  &if ( &psr & (1 << 14)) {  &__asm__ (\\"mov %0=ip\\" : \\"=r\\"( &ip));  &last_cli_ip =  &ip; } ($x) =  &psr; }  &while (0));
	    }' unless defined(&local_irq_save);
	    eval 'sub local_irq_disable () {
	        eval q( &do { \'unsigned long ip\',  &psr;  &__asm__  &__volatile__ (\\"mov %0=psr;; rsm psr.i;;\\" : \\"=r\\" ( &psr) :: \\"memory\\");  &if ( &psr & (1 << 14)) {  &__asm__ (\\"mov %0=ip\\" : \\"=r\\"( &ip));  &last_cli_ip =  &ip; } }  &while (0));
	    }' unless defined(&local_irq_disable);
	    eval 'sub local_irq_restore {
	        local($x) = @_;
    		eval q( &do { \'unsigned long ip\',  &old_psr,  &psr = ($x);  &__asm__  &__volatile__ (\\";;mov %0=psr; mov psr.l=%1;; srlz.d\\" : \\"=&r\\" ( &old_psr) : \\"r\\" ( &psr) : \\"memory\\");  &if (( &old_psr & (1 << 14))  && !( &psr & (1 << 14))) {  &__asm__ (\\"mov %0=ip\\" : \\"=r\\"( &ip));  &last_cli_ip =  &ip; } }  &while (0));
	    }' unless defined(&local_irq_restore);
	} else {
	    eval 'sub local_irq_save {
	        local($x) = @_;
    		eval q( &__asm__  &__volatile__ (\\"mov %0=psr;; rsm psr.i;;\\" : \\"=r\\" ($x) :: \\"memory\\"));
	    }' unless defined(&local_irq_save);
	    eval 'sub local_irq_disable () {
	        eval q( &__asm__  &__volatile__ (\\";; rsm psr.i;;\\" ::: \\"memory\\"));
	    }' unless defined(&local_irq_disable);
	    eval 'sub local_irq_restore {
	        local($x) = @_;
    		eval q( &__asm__  &__volatile__ (\\";; mov psr.l=%0;; srlz.d\\" :: \\"r\\" ($x) : \\"memory\\"));
	    }' unless defined(&local_irq_restore);
	}
	eval 'sub local_irq_enable () {
	    eval q( &__asm__  &__volatile__ (\\";; ssm psr.i;; srlz.d\\" ::: \\"memory\\"));
	}' unless defined(&local_irq_enable);
	eval 'sub __cli () {
	    eval q( &local_irq_disable ());
	}' unless defined(&__cli);
	eval 'sub __save_flags {
	    local($flags) = @_;
    	    eval q( &__asm__  &__volatile__ (\\"mov %0=psr\\" : \\"=r\\" ($flags) :: \\"memory\\"));
	}' unless defined(&__save_flags);
	eval 'sub __save_and_cli {
	    local($flags) = @_;
    	    eval q( &local_irq_save($flags));
	}' unless defined(&__save_and_cli);
	eval 'sub save_and_cli {
	    local($flags) = @_;
    	    eval q( &__save_and_cli($flags));
	}' unless defined(&save_and_cli);
	if(defined(&CONFIG_IA64_SOFTSDV_HACKS)) {
	    eval 'sub get_itc {
	        local($x) = @_;
    		eval q( &__asm__  &__volatile__(\\"mov %0=ar.itc\\" : \\"=r\\"(($x)) :: \\"memory\\"));
	    }' unless defined(&get_itc);
	    eval 'sub get_itm {
	        local($x) = @_;
    		eval q( &__asm__  &__volatile__(\\"mov %0=cr.itm\\" : \\"=r\\"(($x)) :: \\"memory\\"));
	    }' unless defined(&get_itm);
	    eval 'sub set_itm {
	        local($x) = @_;
    		eval q( &__asm__  &__volatile__(\\"mov cr.itm=%0\\" :: \\"r\\"(($x)) : \\"memory\\"));
	    }' unless defined(&set_itm);
	    eval 'sub __restore_flags {
	        local($x) = @_;
    		eval q( &do { \'unsigned long itc\',  &itm;  &local_irq_restore($x);  &get_itc( &itc);  &get_itm( &itm);  &if ( &itc >  &itm)  &set_itm( &itc + 10); }  &while (0));
	    }' unless defined(&__restore_flags);
	    eval 'sub __sti () {
	        eval q( &do { \'unsigned long itc\',  &itm;  &local_irq_enable();  &get_itc( &itc);  &get_itm( &itm);  &if ( &itc >  &itm)  &set_itm( &itc + 10); }  &while (0));
	    }' unless defined(&__sti);
	} else {
	    eval 'sub __sti () {
	        eval q( &local_irq_enable ());
	    }' unless defined(&__sti);
	    eval 'sub __restore_flags {
	        local($flags) = @_;
    		eval q( &local_irq_restore($flags));
	    }' unless defined(&__restore_flags);
	}
	if(defined(&CONFIG_SMP)) {
	    eval 'sub cli () {
	        eval q( &__global_cli());
	    }' unless defined(&cli);
	    eval 'sub sti () {
	        eval q( &__global_sti());
	    }' unless defined(&sti);
	    eval 'sub save_flags {
	        local($flags) = @_;
    		eval q((($flags) =  &__global_save_flags()));
	    }' unless defined(&save_flags);
	    eval 'sub restore_flags {
	        local($flags) = @_;
    		eval q( &__global_restore_flags($flags));
	    }' unless defined(&restore_flags);
	} else {
	    eval 'sub cli () {
	        eval q( &__cli());
	    }' unless defined(&cli);
	    eval 'sub sti () {
	        eval q( &__sti());
	    }' unless defined(&sti);
	    eval 'sub save_flags {
	        local($flags) = @_;
    		eval q( &__save_flags($flags));
	    }' unless defined(&save_flags);
	    eval 'sub restore_flags {
	        local($flags) = @_;
    		eval q( &__restore_flags($flags));
	    }' unless defined(&restore_flags);
	}
	eval 'sub IA64_FETCHADD {
	    local($tmp,$v,$n,$sz) = @_;
    	    eval q(({  &switch ($sz) {  &case 4:  &__asm__  &__volatile__ ( &IA64_SEMFIX\\"fetchadd4.rel %0=[%1],%2\\" : \\"=r\\"($tmp) : \\"r\\"($v), \\"i\\"($n) : \\"memory\\");  &break;  &case 8:  &__asm__  &__volatile__ ( &IA64_SEMFIX\\"fetchadd8.rel %0=[%1],%2\\" : \\"=r\\"($tmp) : \\"r\\"($v), \\"i\\"($n) : \\"memory\\");  &break;  &default:  &__bad_size_for_ia64_fetch_and_add(); } }));
	}' unless defined(&IA64_FETCHADD);
	eval 'sub ia64_fetch_and_add {
	    local($i,$v) = @_;
    	    eval q(({  &__u64  &_tmp;  &volatile  &__typeof__(*($v)) * &_v = ($v);  &switch ($i) {  &case -16:  &IA64_FETCHADD( &_tmp,  &_v, -16, $sizeof{($v)});  &break;  &case -8:  &IA64_FETCHADD( &_tmp,  &_v, -8, $sizeof{($v)});  &break;  &case -4:  &IA64_FETCHADD( &_tmp,  &_v, -4, $sizeof{($v)});  &break;  &case -1:  &IA64_FETCHADD( &_tmp,  &_v, -1, $sizeof{($v)});  &break;  &case 1:  &IA64_FETCHADD( &_tmp,  &_v, 1, $sizeof{($v)});  &break;  &case 4:  &IA64_FETCHADD( &_tmp,  &_v, 4, $sizeof{($v)});  &break;  &case 8:  &IA64_FETCHADD( &_tmp,  &_v, 8, $sizeof{($v)});  &break;  &case 16:  &IA64_FETCHADD( &_tmp,  &_v, 16, $sizeof{($v)});  &break;  &default:  &_tmp =  &__bad_increment_for_ia64_fetch_and_add();  &break; } ( &__typeof__(*$v)) ( &_tmp + ($i)); }));
	}' unless defined(&ia64_fetch_and_add);
	eval 'sub xchg {
	    local($ptr,$x) = @_;
    	    eval q((( &__typeof__(*))  &__xchg ( ($x), ($ptr), $sizeof{($ptr)})));
	}' unless defined(&xchg);
	eval 'sub __HAVE_ARCH_CMPXCHG () {1;}' unless defined(&__HAVE_ARCH_CMPXCHG);
	eval 'sub ia64_cmpxchg {
	    local($sem,$ptr,$old,$new,$size) = @_;
    	    eval q(({  &__typeof__  &_p_ = ;  &__typeof__  &_n_ = ;  &__u64  &_o_,  &_r_;  &switch {  &case 1:  &_o_ = ;  &break;  &case 2:  &_o_ = ;  &break;  &case 4:  &_o_ = ;  &break;  &case 8:  &_o_ = ($old);  &break;  &default:  &break; }  &__asm__  &__volatile__ (\\"mov ar.ccv=%0;;\\" :: \\"rO\\"( &_o_));  &switch ($size) {  &case 1:  &__asm__  &__volatile__ ( &IA64_SEMFIX\\"cmpxchg1.\\"$sem\\" %0=[%1],%2,ar.ccv\\" : \\"=r\\"( &_r_) : \\"r\\"( &_p_), \\"r\\"( &_n_) : \\"memory\\");  &break;  &case 2:  &__asm__  &__volatile__ ( &IA64_SEMFIX\\"cmpxchg2.\\"$sem\\" %0=[%1],%2,ar.ccv\\" : \\"=r\\"( &_r_) : \\"r\\"( &_p_), \\"r\\"( &_n_) : \\"memory\\");  &break;  &case 4:  &__asm__  &__volatile__ ( &IA64_SEMFIX\\"cmpxchg4.\\"$sem\\" %0=[%1],%2,ar.ccv\\" : \\"=r\\"( &_r_) : \\"r\\"( &_p_), \\"r\\"( &_n_) : \\"memory\\");  &break;  &case 8:  &__asm__  &__volatile__ ( &IA64_SEMFIX\\"cmpxchg8.\\"$sem\\" %0=[%1],%2,ar.ccv\\" : \\"=r\\"( &_r_) : \\"r\\"( &_p_), \\"r\\"( &_n_) : \\"memory\\");  &break;  &default:  &_r_ =  &__cmpxchg_called_with_bad_pointer();  &break; } ( &__typeof__($old))  &_r_; }));
	}' unless defined(&ia64_cmpxchg);
	eval 'sub cmpxchg_acq {
	    local($ptr,$o,$n) = @_;
    	    eval q( &ia64_cmpxchg(\\"acq\\", ($ptr), ($o), ($n), $sizeof{($ptr)}));
	}' unless defined(&cmpxchg_acq);
	eval 'sub cmpxchg_rel {
	    local($ptr,$o,$n) = @_;
    	    eval q( &ia64_cmpxchg(\\"rel\\", ($ptr), ($o), ($n), $sizeof{($ptr)}));
	}' unless defined(&cmpxchg_rel);
	eval 'sub cmpxchg {
	    local($ptr,$o,$n) = @_;
    	    eval q( &cmpxchg_acq($ptr,$o,$n));
	}' unless defined(&cmpxchg);
	if(defined(&CONFIG_IA64_DEBUG_CMPXCHG)) {
	    eval 'sub CMPXCHG_BUGCHECK_DECL () {\'int\'  &_cmpxchg_bugcheck_count = 128;;}' unless defined(&CMPXCHG_BUGCHECK_DECL);
	    eval 'sub CMPXCHG_BUGCHECK {
	        local($v) = @_;
    		eval q( &do {  &if ( &_cmpxchg_bugcheck_count-- <= 0) {  &void * &ip;  &extern \'int\'  &printk( &const \'char\' * &fmt, ...);  &asm (\\"mov %0=ip\\" : \\"=r\\"( &ip));  &printk(\\"CMPXCHG_BUGCHECK: stuck at %p on word %p\\\\n\\",  &ip, ($v));  &break; } }  &while (0));
	    }' unless defined(&CMPXCHG_BUGCHECK);
	} else {
	    eval 'sub CMPXCHG_BUGCHECK_DECL () {1;}' unless defined(&CMPXCHG_BUGCHECK_DECL);
	    eval 'sub CMPXCHG_BUGCHECK {
	        local($v) = @_;
    		eval q();
	    }' unless defined(&CMPXCHG_BUGCHECK);
	}
	if(defined(&__KERNEL__)) {
	    eval 'sub prepare_to_switch () {
	        eval q( &do { }  &while(0));
	    }' unless defined(&prepare_to_switch);
	    if(defined(&CONFIG_IA32_SUPPORT)) {
		eval 'sub IS_IA32_PROCESS {
		    local($regs) = @_;
    		    eval q(( &ia64_psr($regs)-> &is != 0));
		}' unless defined(&IS_IA32_PROCESS);
	    } else {
		eval 'sub IS_IA32_PROCESS {
		    local($regs) = @_;
    		    eval q(0);
		}' unless defined(&IS_IA32_PROCESS);
	    }
	    eval 'sub __switch_to {
	        local($prev,$next,$last) = @_;
    		eval q( &do {  &if ((($prev)-> ($thread->{flags}) & ( &IA64_THREAD_DBG_VALID| &IA64_THREAD_PM_VALID)) ||  &IS_IA32_PROCESS( &ia64_task_regs($prev)))  &ia64_save_extra($prev);  &if ((($next)-> ($thread->{flags}) & ( &IA64_THREAD_DBG_VALID| &IA64_THREAD_PM_VALID)) ||  &IS_IA32_PROCESS( &ia64_task_regs($next)))  &ia64_load_extra($next); ($last) =  &ia64_switch_to(($next)); }  &while (0));
	    }' unless defined(&__switch_to);
	    if(defined(&CONFIG_SMP)) {
		eval 'sub switch_to {
		    local($prev,$next,$last) = @_;
    		    eval q( &do {  &if ( &ia64_psr( &ia64_task_regs($prev))-> &mfh) {  &ia64_psr( &ia64_task_regs($prev))-> &mfh = 0; ($prev)-> ($thread->{flags}) |=  &IA64_THREAD_FPH_VALID;  &__ia64_save_fpu(($prev)-> ($thread->{fph})); }  &ia64_psr( &ia64_task_regs($prev))-> &dfh = 1;  &__switch_to($prev,$next,$last); }  &while (0));
		}' unless defined(&switch_to);
	    } else {
		eval 'sub switch_to {
		    local($prev,$next,$last) = @_;
    		    eval q( &do {  &ia64_psr( &ia64_task_regs($next))-> &dfh = ( &ia64_get_fpu_owner() != ($next));  &__switch_to($prev,$next,$last); }  &while (0));
		}' unless defined(&switch_to);
	    }
	}
    }
}
1;
